
ppc = GetNewView; // user interaction, e.g. keys
// HW1 Set current view in HW
Clear(fb); // HW2 step 1, clear HW fb
for all tm in scene // iterate over all triangle meshes in the scene
// BEGIN: HW3 step 2, render triangle mesh in HW
  for all vertices v in tm // iterate over all vertices in curr triangle mesh
    v1 = ppc.Project(v)
  for all triangles t in tm
    aabb = ComputeAxisAlignedBoundingBox;
    aabb1 = Clip(aabb, fb);
    Setup edge equations;
    Setup rasterization parameter interpolation in screen space
    Setup rasterization parameter interpolation in model space
    for all rows v in aabb1
      for all columns u in aabb1
        if (u, v) on wrong side of any of the edges, continue
        currz = Interpolate(z, u, v)
        if currz farther than zb(u, v)
          continue;
        zb(u, v) = currz;
        fb(u, v) = InterpolatedColor(u, v)
// END: HW3 step 2, render triangle mesh in HW

// Fixed pipeline hw rendering
Clear framebuffer //HW1
SetView // HW2 intrinsics + extrinsics
For all triangle meshes
  Draw triangle mesh in HW // HW3

// Programmable pipeline
Clear framebuffer
SetView
For each triangle mesh tm
  for each vertex v of tm

    v' = Project(v)
    OR
    v' = VERTEXSHADER(v) // First point where programmability is exposed

  for each triangle t of tm

    listOfTriangles' = GEOMETRYSHADER(t) // Second point where programmability is exposed

    aabb = AABB(projected vertices of t)
    aabb' = aabb.ClippedToFrame
    RasterizationParameterInterpolationSetup(RP0, RP1, RP2, ...)
    for int v = aabb.top to aabb.bottom
      for int u = aabb.left to aabb.right
        if (u, v) outside projected triangle 
          continue
        currz = z(u, v)

        {
          if currz farther than ZB[u, v]
            continue
          ZB[u, v] = currz
          FB(u, v) = Shade(RP0(u, v), RP1(u, v), ...) 
        }
        OR
        {
          (R, G, B, [Z])' = PIXELSHADER(RP0(u, v), RP1(u, v), ...) // Third point where you can program the GPU
          if Z farther than ZB[u, v]
            continue
          ZB[u, v] = Z
          FB(u, v) = (R, G, B)
        }

